---
Name: migrate-esxi-enable-ssh
Description: Make sure ssh is enabled and configured to communicate via root account.
Documentation: |
  This task renders the `/tmp/migrate-esxi-agent.sh` which will be called later by the `migrate-esxi-agent` task. It also configures the ssh service temporarily.  It should run from the machine context.
Meta:
  color: red
  icon: truck
Templates:
  - Name: migrate-esxi-agent.sh
    ID: migrate-esxi-agent.sh.tmpl
    Path: /tmp/migrate-esxi-agent.sh
    Meta:
      color: red
      icon: truck
  - Name: migrate-esxi-enable-ssh.sh
    Meta:
      color: red
      icon: truck
    Contents: |-
      #!/usr/bin/env sh

      set -e
      {{ if eq (.Param "rs-debug-enable") true}}set -x{{ end }}

      chmod +x /tmp/migrate-esxi-agent.sh

      {{ if eq (.Param "esxi/shell-remote") true }}
      echo The ssh service is already started.
      {{ else }}
      echo Starting the ssh service.
      vim-cmd hostsvc/enable_ssh
      vim-cmd hostsvc/start_ssh
      esxcli system settings advanced set -o /UserVars/SuppressShellWarning -i 1
      touch /tmp/drp-migrate-disable-ssh
      {{ end }}

      if [[ -f /etc/ssh/keys-root/authorized_keys ]]; then
        echo Making a backup of /etc/ssh/keys-root/authorized_keys.
        if [[ ! -f /etc/ssh/keys-root/drp-migrate.authorized_keys.bak ]]; then
          cp /etc/ssh/keys-root/authorized_keys /etc/ssh/keys-root/drp-migrate.authorized_keys.bak
        else
          echo A backup has already been found.  Please review manually before continuing.
          exit 1
        fi
      fi

      echo Setting ssh public key.
      {{ if .ParamExists "migrate-machine/esxi-ssh-pub-key" }}
      mkdir -p /etc/ssh/keys-root
      echo "{{ .Param "migrate-machine/esxi-ssh-pub-key" }}" > /etc/ssh/keys-root/authorized_keys
      {{ else }}
      echo "The parameter 'migrate-machine/esxi-ssh-pub-key' is not set on the machine."
      exit 1
      {{ end }}
      chmod 0400 /etc/ssh/keys-root/authorized_keys
      echo The ssh service is configured.
